Auto Multiple Choice - Bug # 293: "Linux Libertine O" ne marche pas sous OS X

Status: WontFix Priority: Normal
Author: Akim Demaille Category:
Created: 07/17/2014 Assignee: Alexis Bienveniie
Updated: 01/06/2016 Due date:
Description: Bonjour,
En mode texte, AMC code en dur le nom de sa police dans le fichier LaTeX généré, "Linux Libertine O". Et ¢4
ne marche pas. Il y a une tonne de commentaire sur StackOverflow au sujet de cette police, qui pose
manifestement pas mal de probléme (en fait mon kpsearch se plaint méme de la présence d'espace dans le
nom de fichier comme étant invalide).
Il'y a une réponse précieuse de J. Wright ici :
http://tex.stackexchange.com/questions/127240/how-to-install-a-font-on-mactex-2013
(c'est aujourd'hui celle qui est tout en bas).
La partie importante de son message est :
<pre>
XeTeX uses system-dependent code to load fonts, hence it's quite
possible to see differences between how Windows and Mac installations
find fonts. What will always work is looking not for the 'friendly’
name of the font but the font file name:
\documentclass{article}
\usepackage{fontspec}
\setmainfont[Ligatures=TeX,Numbers=0IldStyle]{LinLibertine_R.otf}
\begin{document}
Testing, 1, 2, 3.
\end{document}
</pre>
J'ai essayé, et ca marche sur OS X. Je n'ai pas vérifié sur d'autres plateformes, mais quelqu'un comme
Joseph Wright a forcément raison :) Je propose donc le patch suivant :
<pre>
--- /tmp/plain.pm02014-07-17 12:50:42.000000000 +0200
+++ /opt/local/lib/perl5/vendor_perl/AMC/Filter/plain.pm02014-07-17 12:51:25.000000000 +0200
@@ -74,7 +74,7 @@
{'latexengine'=>'xelatex’,'xItxtra'=>1,
‘questionblocks'=>1,'shufflequestions'=>1,
‘completemulti'=>1,
- 'font'=>'Linux Libertine O',
+ ‘font'=>'LinLibertine_R.otf',
'arabicfont'=>'Rasheeq’,
‘defaultscoringm’'=>'haut=2',
'l-name'=>__("Name and surname"),
</pre>
History
07/17/2014 01:50 pm - Alexis Bienveniie

Est-ce que ¢a marche en utilisant I'option générale suivante dans le fichier AMC-TXT (au lieu de mofifier le programme lui-méme) ?
<pre>

Font: LinLibertine_R.otf

</pre>

07/17/2014 01:54 pm - Akim Demaille
Bonjour Alexis,

Alexis Bienvenue wrote:
> Est-ce que ¢a marche en utilisant I'option générale suivante dans le fichier AMC-TXT (au lieu de mofifier le programme lui-méme) ?

Ga marche strement, si cette option existe. J'ai méme pas essayé puisque la recherche dans la doc ne donnait rien. Toujours est-il que ¢a parait plus
pertinent de la part d'amc d'utiliser les noms portables plutét que de demander aux utilisateurs de penser a modifier la font par défaut. Je maintiens

donc ma suggestion de patch.
07/19/2014 04:15 pm - Alexis Bienveniie
Je suis d'accord avec vous (j'ai intégré votre modification). Je cherchais simplement un moyen de contourner le probléme en attendant une mise a jour

d'AMC sur MacOSX.

07/19/2014 04:21 pm - Akim Demaille
Bonjour Alexis,

Merci pour la réaction rapide.

Alexis Bienvenue wrote:

> Je suis d'accord avec vous (j'ai intégré votre modification). Je cherchais simplement un moyen de contourner le probléme en attendant une mise a
jour d'AMC sur MacOSX.

Ga va, éditer un bout de Perl ne me fait pas peur :) Il y a cependant deux soucis que je n'ai pas traités :

* étendre la documentation pour parler de Font:

* maintenant j'ai un warning inquiétant mais inoffensif au sujet de LinLibertine_R.otf: la procédure utilisée par AMC pour savoir si cette police existe
échoue sous ce nom, d'ou une fenétre pop-up pas sympa. Mais pourtant ga marche.

Je ne sais pas quelle est votre procédure pour tester la présence de cette police, mais ceci marche :

<pre>

$ kpsewhich LinLibertine_R.otf

/opt/local/share/texmf-texlive/fonts/opentype/public/libertine/LinLibertine_R.otf

</pre>

07/19/2014 04:50 pm - Alexis Bienveniie
- % Done changed from 0 to 100

- Status changed from New to Resolved

Applied in changeset commit:443ea7c1a4c2.

07/19/2014 04:51 pm - Alexis Bienveniie
> éditer un bout de Perl ne me fait pas peur :)

Je pensais aux autres utilisateurs.

> |la procédure utilisée par AMC pour savoir si cette police existe échoue sous ce nom, d'ou une fenétre pop-up pas sympa. Mais pourtant ga marche.
J'ai affiné la procédure dans le commit commit:443ea7c1a4c2 qui intégre votre modification. Ceci devrait enlever I'avertissement.

07/19/2014 04:55 pm - Akim Demaille
Alexis Bienvenue wrote:
> > éditer un bout de Perl ne me fait pas peur :)

> Je pensais aux autres utilisateurs.

Ah, désolé, comme je n'avais pas vu d'autres messages a ce sujet...

> > la procédure utilisée par AMC pour savoir si cette police existe échoue sous ce nom, d'ou une fenétre pop-up pas sympa. Mais pourtant ca
marche.

> J'ai affiné la procédure dans le commit commit:443ea7c1a4c2 qui intégre votre modification. Ceci devrait enlever l'avertissement.

FWIW Perl fournit une fonction quotemeta, mais je suppose que ¢a ou "Q$_\E" est une question de style.

Je n'ai pas le context du patch sous les yeux, mais le print ressemble a du debug qui traine.

07/20/2014 10:05 am - Alexis Bienveniie
Merci pour votre relecture instructive : j'ai corrigé (et appris des choses).

07/20/2014 11:44 am - Akim Demaille
Alexis Bienvenlie wrote:

> Merci pour votre relecture instructive : j'ai corrigé (et appris des choses).

Dans ce cas la, j'en ai une derniére pour vous :) D'une part le $_ est implicite :

<pre>
$ perl -e 'print map { quotemeta } (".", "|", "\$"), "\n";'
NS\

</pre>

et d'autre part map admet une syntaxe plus Iégéere pour les noms de fonction :

<pre>
$ perl -e 'print map(quotemeta, ".", "[", "\$"), "\n";'
\\\$

</pre>

Et finalement, grep permet de filtrer les lignes directement depuis un fichier. C'est moins efficace que de sortir au premier match, c'est vrai. Mais si le

fichier est court...

<pre>
$ perl -e 'my $r = join("|", map(quotemeta, ".", "|", "\$"));
print grep(/$r/, <STDIN>), "\n";' << EOF

1

© & —

EOF
|
$

</pre>

($ok = grep... dans votre cas).

08/19/2014 06:17 am - Anirvan Sarkar

- Target version set to 1.3.0

- Assignee set to Alexis Bienveniie

- Status changed from Resolved to Closed

03/22/2015 11:26 am - Alexis Bienveniie

- Status changed from Closed to New

Je m'apergois finalement que le correctif rend impossible I'utilisation de textes en italique ou gras (voir message#3219), car il fixe la version de la police
de caractéres a utiliser avec le @_R@.
Ceci n'est pas acceptable.

Voyez-vous une autre maniére de résoudre ce probleme?

03/23/2015 10:34 am - Akim Demaille

Salut Alexis,

Alexis Bienvenue wrote:
> Je m'apercois finalement que le correctif rend impossible I'utilisation de textes en italique ou gras (voir message#3219), car il fixe la version de la

police de caractéres a utiliser avec le @_R@.

Arg, mince... Je n'avais pas remarqué.

> Ceci n'est pas acceptable.

Bien s(r.

> Voyez-vous une autre maniére de résoudre ce probleme?

En cherchant un peu, j'ai trouvé ¢a : http://tex.stackexchange.com/questions/31739/specify-different-fonts-for-bold-and-italic-with-fontspec . Du coup,

apres un petit “Is’ pour voir les fichiers sur ma machine, je propose:

<pre>
\documentclass{article}
\usepackage{fontspec}
\setmainfont[
Ligatures=TeX,
Numbers=0ldStyle,
BoldFont={LinLibertine_RB.otf},
ItalicFont={LinLibertine_RI.otf},
BoldltalicFont={LinLibertine_RBI.otf}
J{LinLibertine_R.otf}
\begin{document}
Testing, 1, 2, 3.

\emph{Testing, 1, 2, 3.}

\textbf{Testing, 1, 2, 3.}

\textbf{\emph{Testing, 1, 2, 3.}}
\end{document}

</pre>

03/23/2015 10:58 am - Alexis Bienveniie

Est-ce que ¢a marche en remplagant le @\setmainfont@ par le code suivant ?
<pre>

\usepackage{libertine}

\usepackage[T1]{fontenc}

</pre>

Ou avec @biolinum@ au lieu de @libertine@ ?

03/23/2015 11:13 am - Akim Demaille

Alexis Bienvenle wrote:

> Est-ce que ga marche en remplagant le @\setmainfont@ par le code suivant ?
Non : pas d'italique etc.

> Ou avec @biolinum@ au lieu de @libertine@ ?

Cette fois, oui.

<pre>

\documentclass{article}

\usepackage{biolinum}

\usepackage[T1]{fontenc}

\begin{document}
Testing, 1, 2, 3.

\emph{Testing, 1, 2, 3.}

\textbf{Testing, 1, 2, 3.}

\textbf{\emph{Testing, 1, 2, 3.}}

\end{document}

</pre>

04/27/2015 11:37 am - Joél Brogniart

Ah, voila qui permet de résoudre mon probléme. Sur mon installation (OS X 10.10.3, AMC @ commit 7fc79da), si j'utilise le fichier source suivant, les
parties en gras et italique apparaissent correctement.

<pre>

# AMC-TXT source

# Examen de Truc, session 1, janvier 2015

07/11/2025 5/7



PaperSize: A4

Lang: FR

#OK

#Font: Helvetica

Font: Linux Libertine O

Title: Examen de Truc, session 1, janvier 2015

Presentation:

Veuillez répondre aux questions [*ci-dessous*] [_du mieux que vous pouvez_].

* Quelle est la capitale du [*Cameroun®] ?
+ Yaoundé

- Douala

- Kribi

** Parmi les nombres suivants, lesquels sont [_positifs_] ?
+2

-2

+10

</pre>

Il faudrait que je fasse un peu de nettoyage sur ma machine pour voir quelle est la version de la police qui est prise en compte (celle que j'ai installé

dans OS X ou celle installée avec le package TexLive).

04/28/2015 12:23 pm - Alexis Bienveniie
Comment avez-vous installé la police _Linux Libertine_ ? D'aprés les références ci-dessus, il semblerait que ce ne soit pas évident de la faire

fonctionner avec LaTeX...

04/28/2015 04:57 pm - Akim Demaille
Alexis Bienvenue wrote:
> Comment avez-vous installé la police _Linux Libertine_ ? D'apres les références ci-dessus, il semblerait que ce ne soit pas évident de la faire

fonctionner avec LaTeX...

C'est pas clair auquel d'entre nous vous parlez. Au cas ou :

<pre>

$ port provides /opt/local/share/texmi-texlive/tex/latex/libertine/TS1LinuxLibertineT-TLF.fd
/opt/local/share/texmf-texlive/tex/latex/libertine/TS1LinuxLibertineT-TLF.fd is provided by: texlive-fonts-extra
</pre>

04/29/2015 05:24 pm - Joél Brogniart

Alexis Bienvenue wrote:

> Comment avez-vous installé la police _Linux Libertine_ ? D'apres les références ci-dessus, il semblerait que ce ne soit pas évident de la faire
fonctionner avec LaTeX...

Je suppose que c'est pour moi. Je viens juste de voir la question.

J'ai installé la police dans le dossier @/Library/Fonts@ (voir [[Installation_d'AMC_sous_OS_X]]) pour qu'elle soit bien prise en compte.

01/06/2016 09:28 am - Alexis Bienveniie
- Status changed from New to WontFix
